@echo off
rem Codepage wechseln fr Umlaute 
chcp 1252 > nul
:: ================== KONFIG PARAMETER ==================================
set CASAPPUSER=ccl\servicecas
set CASUSERGRP=ccl\Domnen-Benutzer
set xIstReplikant=0

rem set xdcomperm="\\GENESISAPP\DISK\DCOMPERM"
set xdcomperm="DCOMPERM"

:: ======================================================================
chcp 850 > nul


set xclientos=OS64
if "A%ProgramFiles(x86)%"=="A" set xclientos=OS32


echo Lokale DCOM Einstellungen anpassen...

:: Standard Zugriffsberechtigungen bearbeiten
%xdcomperm% -da set ".\Distributed COM-Benutzer" permit level:l,r 			> %temp%\batdiag.txt
FIND /i /c "ERROR" %temp%\batdiag.txt > nul
if NOT errorlevel 1 goto FehlerDcom


:: Standard Aktivierungsberechtigungen bearbeiten
%xdcomperm% -dl set ".\Distributed COM-Benutzer" permit level:l,r,rl,ra		> %temp%\batdiag.txt
FIND /i /c "ERROR" %temp%\batdiag.txt > nul
if NOT errorlevel 1 goto FehlerDcom

:: Limits Zugriffsberechtigungen bearbeiten
%xdcomperm% -ma set ".\Distributed COM-Benutzer" permit level:l,r			> %temp%\batdiag.txt
FIND /i /c "ERROR" %temp%\batdiag.txt > nul
if NOT errorlevel 1 goto FehlerDcom

:: Limits Aktivierungsberechtigungen bearbeiten
%xdcomperm% -ml set ".\Distributed COM-Benutzer" permit level:l,r,rl,ra		> %temp%\batdiag.txt
FIND /i /c "ERROR" %temp%\batdiag.txt > nul
if NOT errorlevel 1 goto FehlerDcom
echo Lokale DCOM Einstellungen angepasst!



echo.

echo "%CASAPPUSER%" Benutzer zu lokalen Administratoren hinzufuegen
net localgroup Administratoren | FIND /i "%CASAPPUSER%" > nul
if errorlevel 1 net localgroup Administratoren "%CASAPPUSER%" /Add

echo "%CASAPPUSER%" Benutzer zu lokalen "Distributed COM-Benutzer" hinzufuegen
net localgroup "Distributed COM-Benutzer" | FIND /i "%CASAPPUSER%" > nul
if errorlevel 1 net localgroup "Distributed COM-Benutzer" "%CASAPPUSER%" /Add

echo "%CASUSERGRP%" zu lokalen "Distributed COM-Benutzer" hinzufuegen
net localgroup "Distributed COM-Benutzer" | FIND /i "%CASUSERGRP%" > nul
if errorlevel 1 net localgroup "Distributed COM-Benutzer" "%CASUSERGRP%" /Add
echo ...


goto %xclientos%

:OS32
echo Benutzerrechte "%ProgramFiles%\Common Files\CAS-Software" setzen
if NOT EXIST "%ProgramFiles%\Common Files\CAS-Software" mkdir "%ProgramFiles%\Common Files\CAS-Software"
cacls "%ProgramFiles%\Common Files\CAS-Software" /T /E /P  %CASAPPUSER%:F >Nul
goto w2

:OS64
echo Benutzerrechte "%ProgramFiles(x86)%\Common Files\CAS-Software" setzen
if NOT EXIST "%ProgramFiles(x86)%\Common Files\CAS-Software" mkdir "%ProgramFiles(x86)%\Common Files\CAS-Software"
cacls "%ProgramFiles(x86)%\Common Files\CAS-Software" /T /E /P  %CASAPPUSER%:F >Nul
goto w2
:w2

if %xIstReplikant%==0 goto keinReplikant

if NOT EXIST C:\CASDATEN mkdir C:\CASDATEN
if NOT EXIST C:\CASDATEN\SQLDATA mkdir C:\CASDATEN\SQLDATA
if NOT EXIST C:\CASDATEN\ARCHIV mkdir C:\CASDATEN\ARCHIV

cacls C:\casdaten /T  /E /P  NETZWERKDIENST:F >nul
cacls C:\casdaten /T  /E /P  %CASAPPUSER%:F   >nul
:keinReplikant


echo SetupNetworkPath aus der Registry loeschen...
reg ADD HKLM\Software\CAS-Software\genesis /v SetupNetworkPath /d "" /f >nul
reg ADD HKCU\Software\CAS-Software\genesis /v SetupNetworkPath /d "" /f >nul
echo.

goto ende:

:FehlerDcom
echo.
echo DCOM Einstellungen fuer \Distributed COM-Benutzer konnten nicht angepasst werden!

:Ende
pause